^TI^'
^TITW^switch (FLAGS) 
^TIS^string cases
^TI^' Command
^P^
The 
^S^cases
 command is a list of alternating 
^S^pattern
 and 
^S^body
 arguments. 
^B^switch
 operates by going along the elements of 
^S^cases
, and attempting to match each 
^S^pattern
 element to 
^S^string
. If it succeeds, then the next element of 
^S^cases
, which is the 
^S^body
 element associated with the successful 
^S^pattern
, is evaluated by the Tcl interpreter, and its result is retuned as 
the result of the 
^B^switch
 statement. The special value '
^B^default
' may be used as the last 
^S^pattern
 in 
^S^cases
; this pattern will successfully match any 
^S^string
 value. If no patterns match, then nothing is done and the command 
returns an empty string.
^P^
Various types of matching--exact, 
^B^glob
-style, or 
^B^regexp
-style--may be specified using the flags to 
^B^switch.
^P^
^TI^'-' as a Body Script
^P^
Specifying a minus sign as one of the 
^S^body
 elements of 
^S^list
 can be used as a convenient method of indicating that the script that 
should be evaluated for this 
^S^body
 is just the same as the script that would be used by the next 
^S^pattern
/
^S^body
 pair. In 
^B^switch
 statements that execute the same code for many different 
^S^pattern
 values, this can save some typing.
^P^
^TI^Alternate Form
^P^
In addition to the syntax specified above, the 
^B^switch
 command may also be used with a slightly different syntax, wherein the 
^S^pattern
 and 
^S^body
 elements of the command are "naked", i.e. they are not contained in a list. 
An invocation of 
^B^switch
 then looks something like "
^B^switch 
^I^string pattern1 body1 pattern2 body2...
", instead of "
^B^switch 
^I^string 
^B^{
^I^pattern1 body1 pattern2 body2...
^B^}
. The advantage of the "naked" form is that since the pattern and body 
elements are not contained in braces, variable and other substitution are 
automatically performed (which is sometimes desired); on the other hand, 
the use of braces to delimit the entire list of pattern/body elements lets 
a switch statement spread across multiple lines without the need to use 
backslashes.




