text $winName
	-width -height -padx -pady
	-relief -borderwidth
	-state -setgrid
	-xscrollcommand -yscrollcommand
#Text Formatting and Appearance:#
	-font -tabs -wrap
	-background -foreground
	-spacing1 -spacing2 -spacing3
#Focus-related:#
	-takefocus -highlightthickness
	-highlightbackground -highlightcolor
#The Selection and the Insertion Point:#
	-insertontime -insertofftime -insertbackground 
	-insertborderwidth -insertwidth
	-selectforeground -selectborderwidth 
	-exportselection

-width w
Specifies the desired width of the window, in terms of the width of the
character '0' in the default font.

-height h
Specifies the number of lines the window should display.

-spacing1 dist
A text line in a text widget is a line containing no newline characters, but ending with
a newline (or the end of document). A text line may wrap to one or more display lines,
if autowrapping is turned on. The 
^B^-spacing1
 option specifies extra space to be
added above text lines (not display lines), and can be overridden using tags.
See also 
^B^-spacing2
 and 
^B^-spacing3
.

-spacing2 dist
This option complements the 
^B^-spacing1
 option: it causes extra vertical distance
to be inserted between the display lines that make up a single text line. It
can be overridden using tags.

-spacing3 dist
Similar to 
^B^-spacing1
, but inserts additional vertical space below a text
line, rather than above it.

-state state
Can be used to allow or disallow editing of 
text in the text widget. When disabled, the insertion cursor will be suppressed; 
however, selections may still be made. To hide the fact that selections are 
occurring, you can use the 
^B^-selectforeground
 option, setting it to the same 
color as the widget's background. 
^P^
^B^Note:
 The value given to the 
^B^state
 option affects editing of the text accomplished internally (such as through 
the use of the 
^B^insert
 command), as well as direct modification.  If you wish to make use of a text 
widget whose contents the user cannot alter, but which can be changed by your code, 
this must be done by enabling the text widget when a change needs to be made,
and then immediately disabling it so the user cannot change it in the future.

-tabs tab-list
Set the default tab stops for the widget. The basic form of the argument is a list
of screen distances representing the tab stops, such as 
^B^{1c 2.5c 4i} 
for tab stops 
at 1 centimetres, 2.5 centimetres, and 4 inches. Any tab stop in the list may be followed 
by one of the keywords 
^B^left
, 
^B^right
, 
^B^center
, or 
^B^numeric
, to obtain tab stops which will be justified in that manner, eg. 
^B^{1c numeric 2.5c left}
. Tabs set using this option may be overridden using tags.

-wrap wrapstyle
Set automatic line wrapping to one of 
^B^none
 (disabled), 
^B^char
 (will put as many characters 
on a line as possible before wrapping), or 
^B^word
 (will put as many words on a line as 
possible before wrapping). Defaults to 
^B^char
.
